﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
 
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim SQLliteQuick As SQL
	'Dim CursorQuickX As Cursor
	'Dim CursorQuickY As Cursor
	'Dim CursorQuickZ As Cursor
	'Dim CursorQuickA As Cursor
	Dim QuerySubject As String
	'Dim Review As Boolean
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private SubjectQuickList As ListView
	

End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	Log("Questions quick subjects")
	
	Activity.LoadLayout("subjectquickquestions")
	Activity.Color = Colors.Black
	Activity.TitleColor= Colors.White
	Activity.Title = "ABC GCSE Science"
'	If FirstTime Then GetData
	Open_and_check_database
	FillQuickQuestionSubjectList

End Sub

Sub Activity_Resume
	SubjectQuickList.Clear
	FillQuickQuestionSubjectList
End Sub

Sub Open_and_check_database
	
	Dim db As String = "makindo_tf.db"
	If File.Exists(File.DirInternal, db) = False Then 
		File.Copy(File.DirAssets, db, File.DirInternal, db)
	Else
		MsgboxAsync("No database files found, please reinstall app", "Abc")
	End If 
		
	
	
	
	If SQLliteQuick.IsInitialized = False Then SQLliteQuick.Initialize(File.DirInternal, db, False)
	
End Sub

Sub SetLVHeights4TextSize(LV As ListView, TwoLine As Boolean, Text1Size As Float, Text2Size As Float, Padding As Float)
	If TwoLine = True Then
		LV.TwoLinesLayout.Label.Top = 0
		LV.TwoLinesLayout.Label.TextSize = Text1Size
		LV.TwoLinesLayout.Label.Height = (Text1Size + (3 * Padding)) * Density
		LV.TwoLinesLayout.SecondLabel.Top = LV.TwoLinesLayout.Label.Height
		LV.TwoLinesLayout.SecondLabel.TextSize = Text2Size
		LV.TwoLinesLayout.SecondLabel.Height = (Text2Size + (3 * Padding)) * Density
		LV.TwoLinesLayout.ItemHeight = LV.TwoLinesLayout.Label.Height + LV.TwoLinesLayout.SecondLabel.Height
		LV.TwoLinesLayout.Label.Gravity = Gravity.CENTER_VERTICAL
		LV.TwoLinesLayout.SecondLabel.Gravity = Gravity.CENTER_VERTICAL
	Else
		LV.SingleLineLayout.Label.Top = 0
		LV.SingleLineLayout.Label.TextSize = Text1Size
		LV.SingleLineLayout.Label.Height = (Text1Size + (3 * Padding)) * Density
		LV.SingleLineLayout.ItemHeight = LV.SingleLineLayout.Label.Height
		LV.SingleLineLayout.Label.Gravity = Gravity.CENTER_VERTICAL
	End If
End Sub


Sub Activity_Pause (UserClosed As Boolean)

End Sub

 


Sub FillQuickQuestionSubjectList  ' gets all subject form the database
	Log ("Get Subjects")
	
	SetLVHeights4TextSize(SubjectQuickList, True, 18, 12 , 5)
	SubjectQuickList.Color=Colors.white
	SubjectQuickList.SingleLineLayout.Label.Color = Colors.white
	SubjectQuickList.SingleLineLayout.Label.TextColor = Colors.DarkGray
	SubjectQuickList.SingleLineLayout.Label.TextSize = 18
	
	SubjectQuickList.TwoLinesLayout.Label.TextColor = Colors.ARGB(255,0,0,128)
	SubjectQuickList.TwoLinesLayout.SecondLabel.TextColor = Colors.ARGB(255, 0,100,0)
	SubjectQuickList.TwoLinesLayout.Label.Color = Colors.White '    Colors.ARGB(255, 211,211,211)
	SubjectQuickList.TwoLinesLayout.SecondLabel.Color = Colors.white 'ARGB(255, 211,211,211)
	
	

	'Dim gd As GradientDrawable
	'gd.Initialize("BOTTOM_TOP", Array As Int (Colors.white, Colors.yellow))
	'SubjectQuickList.SingleLineLayout.Background = gd

	
	CursorQuickX = SQLliteQuick.ExecQuery( "SELECT DISTINCT(subject) FROM main Group by subject;")
'	
	'SubjectQuickList.AddSingleLine("======Subjects======")
		
	
	
'	For i = 0 To CursorQuickX.RowCount - 1
'		CursorQuickX.Position = i
'		Log(CursorQuickX.GetString("subject"))
'		SubjectQuickList.Color = Colors.white
'		SubjectQuickList.AddSingleLine(CursorQuickX.GetString("subject"))
	
	Get_All_Subject_Score_Data		
		
		'SubjectQuickList.AddTwoLines(CursorQuickX.GetString("subject"), y(i) & "/" & z(i) & " attempted. " & a(i) & "/" & y(i) & " correct"  )
	 
	
	'SubjectQuickList.AddSingleLine("Settings")
	'SubjectQuickList.FastScrollEnabled
	
	 
	 
	'SubjectQuickList.AddSingleLine("Refresh Data")
	SubjectQuickList.AddSingleLine("Reset all answers to unattempted")
	SubjectQuickList.AddSingleLine("Update question database")
	 
	
End Sub

Private Sub SubjectQuickList_ItemClick (Position As Int, Value As Object)
	
	'Dim V As String
	'V = Value
	
	If Value = "Refresh Data" Then
		SubjectQuickList.Clear
		FillQuickQuestionSubjectList
		Msgbox("Done", "ABC GCSE Questions")
		Return
	End If
	
	If Value = "Reset all answers to unattempted" Then 
		ResetAnswers
		Return
	End If
	
	If Value = "Update question database" Then
		DownloadUpdate
		Return
	End If
	
	Main.QuerySubjects =  Value
		
	
	StartActivity(quick_questions)
	
End Sub


Private Sub ResetAnswers
	
	SQLliteQuick.ExecNonQuery("update main set attempted = 'False'")
	SQLliteQuick.ExecNonQuery("update main set score = '0'")
	SQLliteQuick.ExecNonQuery("update main set attempt = 'null'")
	 
	
	Msgbox("All Questions set to unattempted", "ABC GCSE Questions")
	SubjectQuickList.Clear
	FillQuickQuestionSubjectList


	
End Sub


Private Sub FillAnswersDatabase
	
	Msgbox("Check Playstore for updates", "ABC GCSE Questions")
	Return
	
	Dim size1,size2, i, z As Int
	size1 = SQLliteQuick.ExecQuerySingleResult("SELECT COUNT(*) FROM main")
	size2 = SQLliteQuick.ExecQuerySingleResult("SELECT COUNT(*) FROM answers")
	i=1
	Log(size1)
	Log(size2)
	
	
	size1 = SQLliteQuick.ExecQuerySingleResult("SELECT COUNT(*) FROM main")
	size2 = SQLliteQuick.ExecQuerySingleResult("SELECT COUNT(*) FROM answers")
	Log(size1)
	Log(size2)
	 
	
	'SELECT COUNT(*) FROM t1;
	
End Sub

 

Private Sub DownloadUpdate
	
	'===========================================================
	'===== DOWNLOAD tiny FILE and check its timestamp with makindo timestamp ========
	'===========================================================
	
	Dim gcse_ts,currdb_ts As Long
	Dim old,new As String
	Dim oldsize,newsize As Int
	Dim olddb_timestamp As String
	Dim newdb_timestamp As String
	

	If File.Exists(File.DirInternal, "newergcse.txt") Then 
	   olddb_timestamp = File.ReadString(File.DirInternal, "newergcse.txt")
	   Log("Found existing one newergcse.txt:" & olddb_timestamp )
	Else
		olddb_timestamp = "00000" ' if never updated before will give an old value
		Log("Non Found:" & olddb_timestamp )
	End If
		
	
	Dim job As HttpJob
	job.Initialize("", Me) 'note that the name parameter is no longer needed.
	job.Download("https://www.abcmedicalnotes.com/quickschoolquestions/newgcse.txt")
	
	Wait For (job) JobDone(job As HttpJob)
	
	' ios we want the file in File.DirDocuments, "makindo.db"
	' android Copy to DirInternal (File.DirAssets, db, File.DirInternal, db)
	
	If job.Success = True Then ' success at donlading newgcse.txt Check if this has been done before
		If File.Exists(File.DirInternal, "newergcse.txt") Then File.Delete(File.DirInternal, "newergcse.txt") ' delete old file
		Log("New gcse txt file found")
		Dim sFile As String = "newergcse.txt" 'downlaoded as new but save it as newergcse.txt
		Dim out As OutputStream = File.OpenOutput(File.DirInternal, sFile, False)
		File.Copy2(job.GetInputStream, out)
		out.Close '<------ very important
		
		If File.Exists(File.DirInternal, "newergcse.txt") Then Log("Found newgcse and saved as newergcse.txt")
		
		newdb_timestamp = File.ReadString(File.DirInternal, "newergcse.txt")
		
		Log(olddb_timestamp)
		Log(newdb_timestamp)
		
		'Log(newdb_timestamp & " " & DateUtils.TicksToString(newdb_timestamp))
	Else
		Log("gcse txt file not found")
		Msgbox("Update not found - check connection", "ABC GCSE")
		Return
	End If
	
	Log("Here 45 ABC GCSE")
	
	job.Release
	'===========================================================
	'===== END OF TINY FILE DOWNLOAD and check its timestamp with makindo timestamp ========
	'===========================================================
	
	
	' newer is bigger
	' there is a new file on the website so we begin update process
	If  newdb_timestamp = olddb_timestamp Then
		Msgbox("The current database is up to date", "ABC GCSE")
		' we update if they dont match as the online file must be newer
		' We avoid downloads only if they match
		Log("Here 46 ABC GCSE ")
		Return  
	End If
	  
	Log("Here 47 ABC GCSE")
		
	' 1) save old atempts into array
	' 2) Download database and replace it
	' 3) Update database
		
	' ======================================================
	' ===== Save current attempts and attempted data into an array
	'===========================================================
	
	
	Dim i = 1 As Int
	Dim size1,size2 As Int
	Dim xrow_id As Int
	size1 = SQLliteQuick.ExecQuerySingleResult("SELECT COUNT(*) FROM main")
		
	oldsize = size1
		
	Dim R As ResultSet = SQLliteQuick.ExecQuery("SELECT rowid, attempt, attempted FROM main order by rowid")
	Dim old_attempted(2000) As String
	Dim old_attempt(2000) As String
	Log("size1=" & size1)
	Do While R.NextRow = True
		xrow_id = R.GetInt("rowid")
			
		old_attempt(xrow_id) = R.GetString("attempt")
		old_attempted(xrow_id) = R.GetString("attempted")
			 
		Log( "rowid=" & xrow_id & "oldattempts =" & old_attempt(xrow_id) & "i = " & i & " " & "oldattempted= " & old_attempted(xrow_id))
			
		If i <> xrow_id Then
			Log("rowid" & xrow_id)
			Msgbox("The current database is out of sync", "ABC GCSE")
			Return
		End If
		
		i = i+1
	Loop
		
	Log("array done check sizes same " & size1 &" "& i)
	R.Close
		
		
	SQLliteQuick.Close ' close current database so we can download and replace the file
	
	'===========================================================
	'===== END OF SAVE ATTEMPTS and ATTEMPTED in ARRAYS ========
	'===========================================================
		
	'===========================================================
	'===== DOWNLOAD NEW DB FILE AND SAVE AND REPLACE IT ========
	'===========================================================
		
	'Delete old file before download
	Log("Here 49 ABC GCSE")
	
		
	' the web database is newer and so we should download it
	job.Initialize("", Me) 'note that the name parameter is no longer needed.
	job.Download("https://www.abcmedicalnotes.com/quickschoolquestions/questions_school.db")
		
	Wait For (job) JobDone(job As HttpJob)
	
	If job.Success = True Then
		File.Delete(File.DirInternal, "makindo.db")
		Dim sFile As String = "makindo.db"
		Dim out As OutputStream = File.OpenOutput(File.Dirinternal, sFile, True)
		File.Copy2(job.GetInputStream, out)
		out.Close '<------ very important
		Log("Download successful")
		Log("============Current Db lastmodified======")
		Log(File.LastModified(File.DirInternal, "makindo.db"))
		'We want the File in DirDocuments, "makindo.db"
	End If
		
	If job.Success = False 	Then
		Log("database file not found")
		Return
	End If
	
	job.Release
	
	Log("Here 50 ABC GCSE")
	' the new file has been saved
		
	'===========================================================
	'===== END OF DOWNLOAD NEW DB FILE AND SAVE AND REPLACE IT ========
	'===========================================================
		
	'===========================================================
	'===== UPDATE DATABASE WITH OLD ATTEMPTS AND ATTEMPTED ========
	'===========================================================
		
		
	' Dim R As ResultSet = SQLliteQuick.ExecQuery("SELECT rowid, attempt, attempted FROM main order by rowid")
	'Dim old_attempted(2000) As Int
	'Dim old_attempts(2000) As Int
		
		
	'===========================================================
	'===== I NO WNEED to reopen database ========
	'===========================================================
	
	If File.Exists(File.DirInternal, "makindo.db") = True Then
		Log("True it is there")
		SQLliteQuick.Initialize(File.DirInternal, "makindo.db", True)
	End If
	
	Log("Here 51 ABC GCSE")
	'===========================================================
	'===== Database was re opened ========
	'===========================================================
		
		
	Dim i = 1 As Int
		 
	size2 = SQLliteQuick.ExecQuerySingleResult("SELECT COUNT(*) FROM main")
		
	newsize = size2
	'SQLliteQuick.BeginTransaction
	Log (size1 & " " & size2)
	Do While i <= size2
		SQLliteQuick.AddNonQueryToBatch("UPDATE main SET attempt = '" & old_attempt(i) & "', attempted = '" & old_attempted(i) & "' WHERE rowid = " & i,Null)
		Log ("Final write " & i & " a " & old_attempt(i) & " b " & old_attempted(i))
		i=i+1
	Loop
		
	Dim SenderFilter As Object = SQLliteQuick.ExecNonQueryBatch("SQL")
	Wait For (SenderFilter) SQL_NonQueryComplete (Success As Boolean)
	Log("NonQuery: " & Success)
		
		
	R.Close
		 		
	'===========================================================
	'===== END UPDATE DATABASE WITH OLD ATTEMPTS AND ATTEMPTED ========
	'===========================================================
		 		
	'Log(old & " " & oldsize)
	'Log(new & " " & newsize)
				
	'Open_and_check_database '// opens database And checks it thats all
	 
	SubjectQuickList.Clear
	FillQuickQuestionSubjectList
	'File.Delete(File.DirDocuments, "index.db")
	'File.Copy(File.DirDocuments, "File.db", File.DirDocuments, "index.db")
	'MyDataBase.Initialize(File.DirDocuments, "index.db", True)
	'Log("All Updated")
	'GetAllTopicsAndFillTable
		
			
	Msgbox("Succesful update. Check every month", "ABC Medical Notes")
		
		
End Sub
 
Sub Get_All_Subject_Score_Data
	Log("Get_All_Score_Data")
	Dim ResultS As ResultSet =   SQLliteQuick.ExecQuery( "SELECT DISTINCT(subject) FROM main Group by subject;") ' gets a list of ALL SUBJECTS
	'Dim ResultY As ResultSet  = quicksubjects.SQLliteQuick.ExecQuery( "SELECT subject, (COUNT(*)) as yy FROM main where attempted = 'True' Group by subject  ;")
	Dim ResultZ As ResultSet  =  SQLliteQuick.ExecQuery( "SELECT subject, COUNT(*) as cps FROM main GROUP BY subject  ;")
	'Dim ResultA As ResultSet  = quicksubjects.SQLliteQuick.ExecQuery( "SELECT subject, (COUNT(*)) as aa FROM main where attempt = answer Group by subject  ;")
	
	Dim ss(100) As String  ' count all attempted questions by subject
	Dim y(100) As Int  ' count all attempted questions by subject
	Dim z(100) As Int  ' count all questions by subject
	Dim a(100) As Int  ' count all correct questions by subject
	
	Dim i,j As Int
	
	i=0
	j=0
	
	Do While ResultS.NextRow
		ss(i) = ResultS.GetString("subject")
		Log(i & " " & ss(i))
		i = i +1
	Loop
	i=0
	
	Do While ResultZ.NextRow
		z(i) = ResultZ.GetInt("cps")
		Log(i & " " & z(i))
		i = i +1
	Loop
	
	
	
	Do While j <= i
		y(j) = SQLliteQuick.ExecQuerySingleResult("SELECT COUNT(*) FROM main where attempted = 'True' and subject ='" & ss(j) & "'")
		a(j) = SQLliteQuick.ExecQuerySingleResult("SELECT COUNT(*) FROM main where attempt = answer and subject ='" & ss(j) & "'")
		j=j+1
	Loop
	
	j=0
	
	Log ("========================================")
	Do While  j < i
		Log(ss(j) & " attempted = " & y(j) & " subject num = " & z(j)& " correct = " & a(j))
		
		SubjectQuickList.AddTwoLines(ss(j),  a(j) & "/" & y(j) & " correct " &  z(j) & " Questions" )
		
		
		j=j+1
	Loop
	Log ("========================================")

	ResultS.Close
	ResultZ.close
	
	
End Sub
 




'CREATE TABLE "answers" (
'	"rowid"	INTEGER UNIQUE,
'	"attempt"	TEXT,
'	"score"	INTEGER,
'	"subject"	TEXT,
'	PRIMARY KEY("rowid")
');

'CREATE TABLE "main" (
'	"subject"	TEXT,
'	"level"	TEXT,
'	"question"	TEXT,
'	"answer"	NUMERIC,
'	"attempt"	REAL,
'	"date"	REAL,
'	"commentary"	TEXT,
'	"type"	BLOB,
'	"attempted"	TEXT,
'	"score"	INTEGER,
'	"rowid"	INTEGER,
'	PRIMARY KEY("rowid" AUTOINCREMENT)
');

