﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=12.2
@EndOfDesignText@
#Region  Activity Attributes 
#FullScreen: True
	#IncludeTitle: False
	 
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim SQLlite_sba As SQL
	Dim resultset_x As ResultSet
	Dim resultset_y As ResultSet

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private sba_ListView As ListView

End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	
	Log("sba subjects")
	Activity.LoadLayout("sba_subjects")
	Log("SBA2")
	Activity.Color = Colors.Black
	Activity.TitleColor= Colors.White
	Activity.Title = "ABC Medical Finals Questions"
	If FirstTime Then GetData
	Fill_sba_listview
	
	
	'Activity.LoadLayout("subjectquickquestions")
	'Activity.Color = Colors.Black
	'Activity.TitleColor= Colors.White
	'Activity.Title = "ABC GCSE Science"
'	If FirstTime Then GetData
	'Open_and_check_database
	'FillQuickQuestionSubjectList

End Sub


Sub GetData
	
	Dim db As String = "makindo_sba.db"
	If File.Exists(File.DirInternal, db) = False Then
		File.Copy(File.DirAssets, db, File.DirInternal, db)
	Else
		MsgboxAsync("No database files found, please reinstall app", "Abc")
	End If
		
	
	
	
	If SQLlite_sba.IsInitialized = False Then SQLlite_sba.Initialize(File.DirInternal, db, False)
	
	
End Sub



Sub Activity_Resume
	
	sba_ListView.Clear
	Fill_sba_listview

End Sub


Private Sub SubjectSlowList_ItemClick (Position As Int, Value As Object)
	
	
	If Value = "-Reset all" Then
		
		SQLlite_sba.ExecQuery("update Main set attempted = 'False'")
		Msgbox("All Questions set to unattempted", "Abc Medical Finals Question")
		sba_ListView.Clear
		Fill_sba_listview
		Return
		
	End If
	Log("QWERTYUIOP")
	Log(Value)
	sba_screen.query1 = "SELECT  * FROM Main where subject LIKE '%" & Value & "%' and attempted = 'False' and question_type = 'Multiple choice question'"
	StartActivity(sba_screen)
End Sub


Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub SetLVHeights4TextSize(LV As ListView, TwoLine As Boolean, Text1Size As Float, Text2Size As Float, Padding As Float)
	If TwoLine = True Then
		LV.TwoLinesLayout.Label.Top = 0
		LV.TwoLinesLayout.Label.TextSize = Text1Size
		LV.TwoLinesLayout.Label.Height = (Text1Size + (2 * Padding)) * Density
		LV.TwoLinesLayout.SecondLabel.Top = LV.TwoLinesLayout.Label.Height
		LV.TwoLinesLayout.SecondLabel.TextSize = Text2Size
		LV.TwoLinesLayout.SecondLabel.Height = (Text2Size + (2 * Padding)) * Density
		LV.TwoLinesLayout.ItemHeight = LV.TwoLinesLayout.Label.Height + LV.TwoLinesLayout.SecondLabel.Height
		LV.TwoLinesLayout.Label.Gravity = Gravity.CENTER_VERTICAL
		LV.TwoLinesLayout.SecondLabel.Gravity = Gravity.CENTER_VERTICAL
	Else
		LV.SingleLineLayout.Label.Top = 0
		LV.SingleLineLayout.Label.TextSize = Text1Size
		LV.SingleLineLayout.Label.Height = (Text1Size + (2 * Padding)) * Density
		LV.SingleLineLayout.ItemHeight = LV.SingleLineLayout.Label.Height
		LV.SingleLineLayout.Label.Gravity = Gravity.CENTER_VERTICAL
	End If
End Sub





Sub Fill_sba_listview
	Dim q As String
	Log ("Get Subjects")
	
	SetLVHeights4TextSize(sba_ListView, True, 18, 10 , 5)
	sba_ListView.Color=Colors.white
	sba_ListView.SingleLineLayout.Label.TextSize = 14
	sba_ListView.SingleLineLayout.Label.TextColor = Colors.Black
	sba_ListView.TwoLinesLayout.Label.TextColor = Colors.Black
	
	
	Dim gd As GradientDrawable
	gd.Initialize("BOTTOM_TOP", Array As Int (Colors.white, Colors.white))
	sba_ListView.SingleLineLayout.Background = gd
	
	q = "SELECT DISTINCT(subject) FROM Main Group by subject;"
		
	resultset_x = SQLlite_sba.ExecQuery(q)
	
	'CursorY = Starter.SQLlite1.ExecQuery( "SELECT subject, count(subject) FROM Main GROUP by subject;")
	
	resultset_y = SQLlite_sba.ExecQuery( "SELECT subject, (COUNT(*)) as cnt from Main Group by subject ;")
	
	Dim x (100) As Int
	
	 

	sba_ListView.AddSingleLine("Settings Below")
	sba_ListView.AddSingleLine("-Reset all")
	sba_ListView.AddSingleLine("-Get updates")

End Sub



Private Sub sba_ListView_ItemClick (Position As Int, Value As Object)
	'Dim V As String
	'V = Value
	
	If Value = "Refresh Data" Then
		sba_ListView.Clear
		Fill_sba_listview
		Msgbox("Done", "ABC GCSE Questions")
		Return
	End If
	
	If Value = "Reset all answers to unattempted" Then
		ResetAnswers
		Return
	End If
	
	If Value = "Update question database" Then
		DownloadUpdate
		Return
	End If
	
	Main.QuerySubjects =  Value
		
	
	StartActivity(sba_screen)
End Sub



Private Sub ResetAnswers
	
	SQLlite_sba.ExecNonQuery("update main set attempted = 'False'")
	SQLlite_sba.ExecNonQuery("update main set score = '0'")
	SQLlite_sba.ExecNonQuery("update main set attempt = 'null'")
	 
	
	Msgbox("All Questions set to unattempted", "ABC GCSE Questions")
	sba_ListView.Clear
	Fill_sba_listview


	
End Sub



Private Sub DownloadUpdate
	
	'===========================================================
	'===== DOWNLOAD tiny FILE and check its timestamp with makindo timestamp ========
	'===========================================================
	
	Dim gcse_ts,currdb_ts As Long
	Dim old,new As String
	Dim oldsize,newsize As Int
	Dim olddb_timestamp As String
	Dim newdb_timestamp As String
	

	If File.Exists(File.DirInternal, "newergcse.txt") Then 
	   olddb_timestamp = File.ReadString(File.DirInternal, "newergcse.txt")
	   Log("Found existing one newergcse.txt:" & olddb_timestamp )
	Else
		olddb_timestamp = "00000" ' if never updated before will give an old value
		Log("Non Found:" & olddb_timestamp )
	End If
		
	
	Dim job As HttpJob
	job.Initialize("", Me) 'note that the name parameter is no longer needed.
	job.Download("https://www.abcmedicalnotes.com/quickschoolquestions/newgcse.txt")
	
	Wait For (job) JobDone(job As HttpJob)
	
	' ios we want the file in File.DirDocuments, "makindo.db"
	' android Copy to DirInternal (File.DirAssets, db, File.DirInternal, db)
	
	If job.Success = True Then ' success at donlading newgcse.txt Check if this has been done before
		If File.Exists(File.DirInternal, "newergcse.txt") Then File.Delete(File.DirInternal, "newergcse.txt") ' delete old file
		Log("New gcse txt file found")
		Dim sFile As String = "newergcse.txt" 'downlaoded as new but save it as newergcse.txt
		Dim out As OutputStream = File.OpenOutput(File.DirInternal, sFile, False)
		File.Copy2(job.GetInputStream, out)
		out.Close '<------ very important
		
		If File.Exists(File.DirInternal, "newergcse.txt") Then Log("Found newgcse and saved as newergcse.txt")
		
		newdb_timestamp = File.ReadString(File.DirInternal, "newergcse.txt")
		
		Log(olddb_timestamp)
		Log(newdb_timestamp)
		
		'Log(newdb_timestamp & " " & DateUtils.TicksToString(newdb_timestamp))
	Else
		Log("gcse txt file not found")
		Msgbox("Update not found - check connection", "ABC GCSE")
		Return
	End If
	
	Log("Here 45 ABC GCSE")
	
	job.Release
	'===========================================================
	'===== END OF TINY FILE DOWNLOAD and check its timestamp with makindo timestamp ========
	'===========================================================
	
	
	' newer is bigger
	' there is a new file on the website so we begin update process
	If  newdb_timestamp = olddb_timestamp Then
		Msgbox("The current database is up to date", "ABC GCSE")
		' we update if they dont match as the online file must be newer
		' We avoid downloads only if they match
		Log("Here 46 ABC GCSE ")
		Return  
	End If
	  
	Log("Here 47 ABC GCSE")
		
	' 1) save old atempts into array
	' 2) Download database and replace it
	' 3) Update database
		
	' ======================================================
	' ===== Save current attempts and attempted data into an array
	'===========================================================
	
	
	Dim i = 1 As Int
	Dim size1,size2 As Int
	Dim xrow_id As Int
	size1 = SQLlite_sba.ExecQuerySingleResult("SELECT COUNT(*) FROM main")
		
	oldsize = size1
		
	Dim R As ResultSet = SQLlite_sba.ExecQuery("SELECT rowid, attempt, attempted FROM main order by rowid")
	Dim old_attempted(2000) As String
	Dim old_attempt(2000) As String
	Log("size1=" & size1)
	Do While R.NextRow = True
		xrow_id = R.GetInt("rowid")
			
		old_attempt(xrow_id) = R.GetString("attempt")
		old_attempted(xrow_id) = R.GetString("attempted")
			 
		Log( "rowid=" & xrow_id & "oldattempts =" & old_attempt(xrow_id) & "i = " & i & " " & "oldattempted= " & old_attempted(xrow_id))
			
		If i <> xrow_id Then
			Log("rowid" & xrow_id)
			Msgbox("The current database is out of sync", "ABC GCSE")
			Return
		End If
		
		i = i+1
	Loop
		
	Log("array done check sizes same " & size1 &" "& i)
	R.Close
		
		
	SQLlite_sba.Close ' close current database so we can download and replace the file
	
	'===========================================================
	'===== END OF SAVE ATTEMPTS and ATTEMPTED in ARRAYS ========
	'===========================================================
		
	'===========================================================
	'===== DOWNLOAD NEW DB FILE AND SAVE AND REPLACE IT ========
	'===========================================================
		
	'Delete old file before download
	Log("Here 49 ABC GCSE")
	
		
	' the web database is newer and so we should download it
	job.Initialize("", Me) 'note that the name parameter is no longer needed.
	job.Download("https://www.abcmedicalnotes.com/quickschoolquestions/questions_school.db")
		
	Wait For (job) JobDone(job As HttpJob)
	
	If job.Success = True Then
		File.Delete(File.DirInternal, "makindo.db")
		Dim sFile As String = "makindo.db"
		Dim out As OutputStream = File.OpenOutput(File.Dirinternal, sFile, True)
		File.Copy2(job.GetInputStream, out)
		out.Close '<------ very important
		Log("Download successful")
		Log("============Current Db lastmodified======")
		Log(File.LastModified(File.DirInternal, "makindo.db"))
		'We want the File in DirDocuments, "makindo.db"
	End If
		
	If job.Success = False 	Then
		Log("database file not found")
		Return
	End If
	
	job.Release
	
	Log("Here 50 ABC GCSE")
	' the new file has been saved
		
	'===========================================================
	'===== END OF DOWNLOAD NEW DB FILE AND SAVE AND REPLACE IT ========
	'===========================================================
		
	'===========================================================
	'===== UPDATE DATABASE WITH OLD ATTEMPTS AND ATTEMPTED ========
	'===========================================================
		
		
	' Dim R As ResultSet = SQLliteQuick.ExecQuery("SELECT rowid, attempt, attempted FROM main order by rowid")
	'Dim old_attempted(2000) As Int
	'Dim old_attempts(2000) As Int
		
		
	'===========================================================
	'===== I NO WNEED to reopen database ========
	'===========================================================
	
	If File.Exists(File.DirInternal, "makindo.db") = True Then
		Log("True it is there")
		SQLlite_sba.Initialize(File.DirInternal, "makindo.db", True)
	End If
	
	Log("Here 51 ABC GCSE")
	'===========================================================
	'===== Database was re opened ========
	'===========================================================
		
		
	Dim i = 1 As Int
		 
	size2 = SQLlite_sba.ExecQuerySingleResult("SELECT COUNT(*) FROM main")
		
	newsize = size2
	'SQLliteQuick.BeginTransaction
	Log (size1 & " " & size2)
	Do While i <= size2
		SQLlite_sba.AddNonQueryToBatch("UPDATE main SET attempt = '" & old_attempt(i) & "', attempted = '" & old_attempted(i) & "' WHERE rowid = " & i,Null)
		Log ("Final write " & i & " a " & old_attempt(i) & " b " & old_attempted(i))
		i=i+1
	Loop
		
	Dim SenderFilter As Object = SQLlite_sba.ExecNonQueryBatch("SQL")
	Wait For (SenderFilter) SQL_NonQueryComplete (Success As Boolean)
	Log("NonQuery: " & Success)
		
		
	R.Close
		 		
	'===========================================================
	'===== END UPDATE DATABASE WITH OLD ATTEMPTS AND ATTEMPTED ========
	'===========================================================
		 		
	'Log(old & " " & oldsize)
	'Log(new & " " & newsize)
				
	'Open_and_check_database '// opens database And checks it thats all
	 
	sba_ListView.Clear
	Fill_sba_listview
	'File.Delete(File.DirDocuments, "index.db")
	'File.Copy(File.DirDocuments, "File.db", File.DirDocuments, "index.db")
	'MyDataBase.Initialize(File.DirDocuments, "index.db", True)
	'Log("All Updated")
	'GetAllTopicsAndFillTable
		
			
	Msgbox("Succesful update. Check every month", "ABC Medical Notes")
		
		
End Sub